<?php
/*
Plugin Name: OrderStorm e&#x2010;Commerce
Plugin URI: http://www.orderstorm.com/wordpress-ecommerce
Description: A plugin to integrate OrderStorm e&#x2011;Commerce with WordPress
Version: 0.4.9.3
Author: OrderStorm, Inc.
Author URI: http://www.orderstorm.com
License: GPL2 or later
*/

/*
	Copyright (C) 2010-2011 OrderStorm, Inc. (e-mail: wordpress-ecommerce@orderstorm.com)
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

$orderstorm_wordpress_e_commerce_configuration = array();
$orderstorm_wordpress_e_commerce_configuration['plugin_version'] = '0.4.9.3';

require_once('CLASS_OrderStormECommerceForWordPress.php');
require_once('CLASS_OrderStormECommerceCategoriesMenu.php');
require_once('CLASS_OrderStormECommerceShoppingCartStatusWidget.php');

$plugin_custom_configuration_url_path = OrderStormECommerceForWordPress::plugin_custom_configuration_url_path();

$custom_localization_script = OrderStormECommerceForWordPress::plugin_custom_configuration_path() . DIRECTORY_SEPARATOR . 'OrderStormEcommerceLocalization.php';
$default_localization_script = OrderStormECommerceForWordPress::plugin_full_path() . DIRECTORY_SEPARATOR . 'OrderStormEcommerceLocalization.php';
if (file_exists($custom_localization_script))
{
	require_once($custom_localization_script);
}
elseif (file_exists($default_localization_script))
{
	require_once($default_localization_script);
}

$custom_categories_menu_widget_css_file = OrderStormECommerceForWordPress::plugin_custom_configuration_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormCategoriesMenuWidget.css';
$default_categories_menu_widget_css_file = OrderStormECommerceForWordPress::plugin_full_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormCategoriesMenuWidget.css';
if (file_exists($custom_categories_menu_widget_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['categories_menu_widget_style_sheet_url'] = $plugin_custom_configuration_url_path . '/' . 'css' . '/' . 'OrderStormCategoriesMenuWidget.css';
}
elseif (file_exists($default_categories_menu_widget_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['categories_menu_widget_style_sheet_url'] = plugin_dir_url(__FILE__) . 'css' . '/' . 'OrderStormCategoriesMenuWidget.css';
}

$custom_product_categories_css_file = OrderStormECommerceForWordPress::plugin_custom_configuration_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormProductCategories.css';
$default_product_categories_css_file = OrderStormECommerceForWordPress::plugin_full_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormProductCategories.css';
if (file_exists($custom_product_categories_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['product_categories_style_sheet_url'] = $plugin_custom_configuration_url_path . '/' . 'css' . '/' . 'OrderStormProductCategories.css';
}
elseif (file_exists($default_product_categories_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['product_categories_style_sheet_url'] = plugin_dir_url(__FILE__) . 'css' . '/' . 'OrderStormProductCategories.css';
}

$custom_products_css_file = OrderStormECommerceForWordPress::plugin_custom_configuration_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormProducts.css';
$default_products_css_file = OrderStormECommerceForWordPress::plugin_full_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormProducts.css';
if (file_exists($custom_products_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['products_style_sheet_url'] = $plugin_custom_configuration_url_path . '/' . 'css' . '/' . 'OrderStormProducts.css';
}
elseif (file_exists($default_products_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['products_style_sheet_url'] = plugin_dir_url(__FILE__) . 'css' . '/' . 'OrderStormProducts.css';
}

$custom_product_details_css_file = OrderStormECommerceForWordPress::plugin_custom_configuration_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormProductDetails.css';
$default_product_details_css_file = OrderStormECommerceForWordPress::plugin_full_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormProductDetails.css';
if (file_exists($custom_product_details_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['product_details_style_sheet_url'] = $plugin_custom_configuration_url_path . '/' . 'css' . '/' . 'OrderStormProductDetails.css';
}
elseif (file_exists($default_product_details_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['product_details_style_sheet_url'] = plugin_dir_url(__FILE__) . 'css' . '/' . 'OrderStormProductDetails.css';
}

$custom_product_details_template_file = OrderStormECommerceForWordPress::plugin_custom_configuration_path() . DIRECTORY_SEPARATOR . 'templates' . DIRECTORY_SEPARATOR . 'render_product_details.php';
$default_product_details_template_file = OrderStormECommerceForWordPress::plugin_full_path() . DIRECTORY_SEPARATOR . 'templates' . DIRECTORY_SEPARATOR . 'render_product_details.php';
if (file_exists($custom_product_details_template_file))
{
	$orderstorm_wordpress_e_commerce_configuration['product_details_template'] = OrderStormECommerceForWordPress::plugin_custom_configuration_path() . DIRECTORY_SEPARATOR . 'templates' . DIRECTORY_SEPARATOR . 'render_product_details.php';
}
elseif (file_exists($default_product_details_template_file))
{
	$orderstorm_wordpress_e_commerce_configuration['product_details_template'] = OrderStormECommerceForWordPress::plugin_full_path() . DIRECTORY_SEPARATOR . 'templates' . DIRECTORY_SEPARATOR . 'render_product_details.php';
}

$custom_shopping_cart_status_tag_css_file = OrderStormECommerceForWordPress::plugin_custom_configuration_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormShoppingCartStatusTag.css';
$default_shopping_cart_status_tag_css_file = OrderStormECommerceForWordPress::plugin_full_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormShoppingCartStatusTag.css';
if (file_exists($custom_shopping_cart_status_tag_css_file))
{
	$shopping_cart_status_tag_style_sheet_url = $plugin_custom_configuration_url_path . '/' . 'css' . '/' . 'OrderStormShoppingCartStatusTag.css';
}
elseif (file_exists($default_shopping_cart_status_tag_css_file))
{
	$shopping_cart_status_tag_style_sheet_url = plugin_dir_url(__FILE__) . 'css' . '/' . 'OrderStormShoppingCartStatusTag.css';
}

$custom_shopping_cart_status_widget_css_file = OrderStormECommerceForWordPress::plugin_custom_configuration_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormShoppingCartStatusWidget.css';
$default_shopping_cart_status_widget_css_file = OrderStormECommerceForWordPress::plugin_full_path() . DIRECTORY_SEPARATOR . 'css' . DIRECTORY_SEPARATOR . 'OrderStormShoppingCartStatusWidget.css';
if (file_exists($custom_shopping_cart_status_widget_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['shopping_cart_status_widget_style_sheet_url'] = $plugin_custom_configuration_url_path . '/' . 'css' . '/' . 'OrderStormShoppingCartStatusWidget.css';
}
elseif (file_exists($default_shopping_cart_status_widget_css_file))
{
	$orderstorm_wordpress_e_commerce_configuration['shopping_cart_status_widget_style_sheet_url'] = plugin_dir_url(__FILE__) . 'css' . '/' . 'OrderStormShoppingCartStatusWidget.css';
}

$fancybox_style_sheet_url = plugin_dir_url(__FILE__) . 'js/fancybox/jquery.fancybox-1.3.4.css';

$GLOBALS['osws'] = new OrderStormECommerceForWordPress($configuration_options = $orderstorm_wordpress_e_commerce_configuration);

add_filter('wp_head', 'orderstorm_ecommerce_flush_rewrite_rules');
add_filter('rewrite_rules_array','orderstorm_ecommerce_insert_rewrite_rules');
add_filter('query_vars','orderstorm_ecommerce_insert_rewrite_query_vars');
add_action('widgets_init', 'orderstorm_ecommerce_load_widgets');
if (is_admin())
{
	register_activation_hook(__FILE__, 'activate_orderstorm_ecommerce_plugin');
	register_deactivation_hook(__FILE__, 'deactivate_orderstorm_ecommerce_plugin');
	add_action('admin_menu', 'create_orderstorm_ecommerce_option_menu');
	add_action('wp_ajax_nopriv_add_to_cart', 'orderstorm_ecommerce_add_to_cart' );
	add_action('wp_ajax_add_to_cart', 'orderstorm_ecommerce_add_to_cart' );
	add_action('wp_ajax_nopriv_submit_product_question', 'orderstorm_ecommerce_submit_product_question');
	add_action('wp_ajax_submit_product_question', 'orderstorm_ecommerce_submit_product_question' );
}
else
{
	wp_enqueue_script('ostrm_mousewheel', plugin_dir_url(__FILE__) . 'js/fancybox/jquery.mousewheel-3.0.4.pack.js', array('jquery'), '3.0.4', false);
	wp_enqueue_script('ostrm_fancy_box', plugin_dir_url(__FILE__) . 'js/fancybox/jquery.fancybox-1.3.4.pack.js', array('jquery'), '1.3.4', false);
	wp_enqueue_script('ostrm_ecommerce_general', plugin_dir_url(__FILE__) . 'js/ostrm_ecommerce_general.js', array('jquery', 'ostrm_mousewheel', 'ostrm_fancy_box'), '1.0', false);
	add_action('wp_print_styles', 'orderstorm_ecommerce_load_categories_menu_widget_style_sheet');
	if (isset($shopping_cart_status_tag_style_sheet_url))
	{
		wp_register_style('orderstorm_ecommerce_shopping_cart_status_tag_style_sheet', $shopping_cart_status_tag_style_sheet_url);
		wp_enqueue_style('orderstorm_ecommerce_shopping_cart_status_tag_style_sheet',false,false,"1.0","screen");
	}
	add_action('wp_print_styles', 'orderstorm_ecommerce_load_shopping_cart_status_widget_style_sheet');
	if (isset($fancybox_style_sheet_url))
	{
		wp_register_style('orderstorm_ecommerce_fancybox_style_sheet', $fancybox_style_sheet_url);
		wp_enqueue_style('orderstorm_ecommerce_fancybox_style_sheet',false,false,"1.3.4","screen");
	}
	$order_key_guid = isset($_SESSION['order_key_guid'])?$_SESSION['order_key_guid']:null;
	wp_localize_script
	(
		'ostrm_ecommerce_general',
		'cartGlobals',
		array
		(
			'orderKeyGUID' => $order_key_guid,
			'checkoutURL' => $GLOBALS['osws']->checkout_url()
		)
	);
	add_action('get_header', 'prepare_pre_header_data');
}

function prepare_pre_header_data()
{
	$product_category_page_id = $GLOBALS['osws']->get_page_id_by_slug($GLOBALS['osws']->get_product_category_page_slug());
	$product_page_id = $GLOBALS['osws']->get_page_id_by_slug($GLOBALS['osws']->get_product_page_slug());
	add_shortcode('orderstorm_ecommerce_display_product_category_page', 'orderstorm_ecommerce_display_product_category_page');
	add_action('wp_print_styles', 'orderstorm_ecommerce_load_product_categories_style_sheet');
	add_action('wp_print_styles', 'orderstorm_ecommerce_load_products_style_sheet');
	if (is_page($product_page_id))
	{
		add_action('wp_print_styles', 'orderstorm_ecommerce_load_product_details_style_sheet');
		wp_enqueue_script('ostrm_product_details_form', plugin_dir_url(__FILE__) . 'js/ostrm_product_details_form.js', array('jquery'), '1.0', false);
		wp_enqueue_script('ostrm_product_question_form', plugin_dir_url(__FILE__) . 'js/ostrm_product_question_form.js', array('jquery'), '1.0', false);
		add_shortcode('orderstorm_ecommerce_display_product_page', 'orderstorm_ecommerce_display_product_page');
		$GLOBALS['osws']->prepare_product_information();
		if ($GLOBALS['osws']->product_has_html5_drawing())
		{
			wp_enqueue_script('ostrm_color_picker', plugin_dir_url(__FILE__) . 'js/jquery.colorpicker.js', array('jquery'), '0.1.0', false);
		}
	}
}

function orderstorm_ecommerce_add_to_cart()
{
	require_once('CLASS_jsonResultSet.php');
	require_once('CLASS_OrderStormECommerceForWordPress.php');
	
	$json_obj = new Moxiecode_JSON();
	$ecommerce_host_name = 'https://' . get_option('orderstorm_ecommerce_host_name', '') . '/orderstorm_ecommerce.os';
	$ws_key_guid = get_option('orderstorm_ecommerce_key_guid', '');
	
	$response = array();
	$response['blnAddSuccessful'] = FALSE;
	$order_key_guid = null;
	$response['blnValidNonce'] = FALSE;
	
	$nonce = '';
	if (isset($_POST['ostrmCartNonce']))
	{
		$nonce = $_POST['ostrmCartNonce'];
	}
	
	if (wp_verify_nonce($nonce, 'orderstorm_nonce'))
	{
		$response['blnValidNonce'] = TRUE;
	}
	
	if ($response['blnValidNonce'] === TRUE)
	{
		session_start();
		
		if (isset($_SESSION['order_key_guid']))
		{
			$order_key_guid = $_SESSION['order_key_guid'];
		}
		
		$features = $_POST['feature'];
		
		$blnFirstFeatureGroup = TRUE;
		$ajax_request = '';
		$ajax_request = $ajax_request . '{';
		$ajax_request = $ajax_request . '"key_GUID":"' . $ws_key_guid . '"';
		$ajax_request = $ajax_request . ',';
		$ajax_request = $ajax_request . '"session_id":"' . session_id() . '"';
		$ajax_request = $ajax_request . ',';
		$ajax_request = $ajax_request . '"service":"add_product"';
		$ajax_request = $ajax_request . ',';
		$ajax_request = $ajax_request . '"arguments":{';
		$ajax_request = $ajax_request . '"product_guid":"' . $_POST['id'] . '"';
		$ajax_request = $ajax_request . ',';
		$ajax_request = $ajax_request . '"order_key_guid":';
		if (is_null($order_key_guid))
		{
			$ajax_request = $ajax_request . 'null';
		}
		else
		{
			$ajax_request = $ajax_request . '"' . $order_key_guid . '"';
		}
		$ajax_request = $ajax_request . ',';
		$ajax_request = $ajax_request . '"quantity":' . $_POST['Quantity'];
		$ajax_request = $ajax_request . ',';
		$ajax_request = $ajax_request . '"ip":"' . $_SERVER['REMOTE_ADDR'] . '"';
		$ajax_request = $ajax_request . ',';
		$ajax_request = $ajax_request . '"features":{';
		foreach($features as $featureGroup => $value)
		{
			if ($blnFirstFeatureGroup === TRUE)
			{
				$blnFirstFeatureGroup = FALSE;
			}
			else
			{
				$ajax_request = $ajax_request . ',';
			}
			$ajax_request = $ajax_request . '"' . $featureGroup . '":';
			if (is_array($value))
			{
				$blnFirstFeature = TRUE;
				foreach($value as $featureProductGUID)
				{
					if ($blnFirstFeature === TRUE)
					{
						$blnFirstFeature = FALSE;
						$ajax_request = $ajax_request . '[';
					}
					else
					{
						$ajax_request = $ajax_request . ',';
					}
					$ajax_request = $ajax_request . '"' . $featureProductGUID . '"';
				}
				if ($blnFirstFeature === FALSE)
				{
					$ajax_request = $ajax_request . ']';
				}
			}
			else
			{
				$ajax_request = $ajax_request . '["' . $value . '"]';
			}
		}
		$ajax_request = $ajax_request . '}';
		$ajax_request = $ajax_request . '}';
		$ajax_request = $ajax_request . '}';
		
		$result =	new jsonResultSet
					(
						$json_obj->decode
						(
							OrderStormECommerceForWordPress::curl_fetch_ajax
							(
								$ecommerce_host_name,
								array('AJAX_Request' => $ajax_request),
								TRUE,
								TRUE
							)
						)
					);
		if ($result->rowCount() === 1)
		{
			$response['blnAddSuccessful'] = TRUE;
			$row = $result->row(0);
			$new_order_key_guid = $row['order_key_guid'];
		}
		
		if (is_null($new_order_key_guid))
		{
			unset($_SESSION['order_key_guid']);
			$response['orderKeyGUID'] = null;
			session_destroy();
		}
		else
		{
			if ($new_order_key_guid != $order_key_guid)
			{
				$_SESSION['order_key_guid'] = $new_order_key_guid;
			}
			$response['orderKeyGUID'] = $new_order_key_guid;
		}
	}
	
	header('Content-type: application/json');
	echo($json_obj->encode($response));
	die();
}

function orderstorm_ecommerce_submit_product_question()
{
	require_once('CLASS_jsonResultSet.php');
	require_once('CLASS_OrderStormECommerceForWordPress.php');
	
	$json_obj = new Moxiecode_JSON();
	$ecommerce_host_name = 'https://' . get_option('orderstorm_ecommerce_host_name', '') . '/orderstorm_ecommerce.os';
	$ws_key_guid = get_option('orderstorm_ecommerce_key_guid', '');
	
	$response = array();
	$response['blnAddSuccessful'] = FALSE;
	$response['blnValidNonce'] = FALSE;
	
	$nonce = '';
	if (isset($_POST['ostrmCartNonce']))
	{
		$nonce = $_POST['ostrmCartNonce'];
	}
	
	if (wp_verify_nonce($nonce, 'orderstorm_nonce'))
	{
		$response['blnValidNonce'] = TRUE;
	}
	
	if ($response['blnValidNonce'] === TRUE)
	{
		$product_guid = $_POST['id'];
		if (OrderStormECommerceForWordPress::isWellFormedGUID($product_guid))
		{
			$question = $_POST['question'];
			if (strip_tags($question) === $question)
			{
				$email = $_POST['email'];
				if (filter_var($email, FILTER_VALIDATE_EMAIL))
				{
					session_start();
					
					$ip = isset($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:null;
					$referer = isset($_SERVER['HTTP_REFERER'])?$_SERVER['HTTP_REFERER']:null;
					
					$ajax_request = '';
					$ajax_request = $ajax_request . '{';
					$ajax_request = $ajax_request . '"key_GUID":"' . $ws_key_guid . '"';
					$ajax_request = $ajax_request . ',';
					$ajax_request = $ajax_request . '"session_id":"' . session_id() . '"';
					$ajax_request = $ajax_request . ',';
					$ajax_request = $ajax_request . '"service":"submit_product_question"';
					$ajax_request = $ajax_request . ',';
					$ajax_request = $ajax_request . '"arguments":{';
					$ajax_request = $ajax_request . '"product_guid":"' . $product_guid . '"';
					$ajax_request = $ajax_request . ',';
					$ajax_request = $ajax_request . '"email":"' . $email . '"';
					$ajax_request = $ajax_request . ',';
					$ajax_request = $ajax_request . '"question":"' . $question . '"';
					$ajax_request = $ajax_request . ',';
					$ajax_request = $ajax_request . '"ip":';
					if (is_null($ip))
					{
						$ajax_request = $ajax_request . 'null';
					}
					else
					{
						$ajax_request = $ajax_request . '"' . $ip . '"';
					}
					$ajax_request = $ajax_request . ',';
					$ajax_request = $ajax_request . '"referer":';
					if (is_null($referer))
					{
						$ajax_request = $ajax_request . 'null';
					}
					else
					{
						$ajax_request = $ajax_request . '"' . $referer . '"';
					}
					$ajax_request = $ajax_request . '}';
					$ajax_request = $ajax_request . '}';
					
					$result =	new jsonResultSet
								(
									$json_obj->decode
									(
										OrderStormECommerceForWordPress::curl_fetch_ajax
										(
											$ecommerce_host_name,
											array('AJAX_Request' => $ajax_request),
											TRUE,
											TRUE
										)
									)
								);
					if ($result->rowCount() === 1)
					{
						$response['blnAddSuccessful'] = TRUE;
					}
				}
				else
				{
					$response['error'] = 3;
				}
			}
			else
			{
				$response['error'] = 2;
			}
		}
		else
		{
			$response['error'] = 1;
		}
	}
	
	header('Content-type: application/json');
	echo($json_obj->encode($response));
	die();
}

function orderstorm_ecommerce_load_categories_menu_widget_style_sheet()
{
	$categories_menu_widget_style_sheet_url = $GLOBALS['osws']->get_option('categories_menu_widget_style_sheet_url');
	if (!empty($categories_menu_widget_style_sheet_url))
	{
		wp_register_style('orderstorm_ecommerce_categories_menu_widget_style_sheet', $categories_menu_widget_style_sheet_url);
		wp_enqueue_style('orderstorm_ecommerce_categories_menu_widget_style_sheet');
	}
}

function orderstorm_ecommerce_load_shopping_cart_status_widget_style_sheet()
{
	$shopping_cart_status_widget_style_sheet_url = $GLOBALS['osws']->get_option('shopping_cart_status_widget_style_sheet_url');
	if (!empty($shopping_cart_status_widget_style_sheet_url))
	{
		wp_register_style('orderstorm_ecommerce_shopping_cart_status_widget_style_sheet', $shopping_cart_status_widget_style_sheet_url);
		wp_enqueue_style('orderstorm_ecommerce_shopping_cart_status_widget_style_sheet');
	}
}

function orderstorm_ecommerce_load_product_categories_style_sheet()
{
	$product_categories_style_sheet_url = $GLOBALS['osws']->get_option('product_categories_style_sheet_url');
	if (!empty($product_categories_style_sheet_url))
	{
		wp_register_style('orderstorm_ecommerce_product_categories_style_sheet', $product_categories_style_sheet_url);
		wp_enqueue_style('orderstorm_ecommerce_product_categories_style_sheet');
	}
}

function orderstorm_ecommerce_load_products_style_sheet()
{
	$products_style_sheet_url = $GLOBALS['osws']->get_option('products_style_sheet_url');
	if (!empty($products_style_sheet_url))
	{
		wp_register_style('orderstorm_ecommerce_products_style_sheet', $products_style_sheet_url);
		wp_enqueue_style('orderstorm_ecommerce_products_style_sheet');
	}
}

function orderstorm_ecommerce_load_product_details_style_sheet()
{
	$product_details_style_sheet_url = $GLOBALS['osws']->get_option('product_details_style_sheet_url');
	if (!empty($product_details_style_sheet_url))
	{
		wp_register_style('orderstorm_ecommerce_product_details_style_sheet', $product_details_style_sheet_url);
		wp_enqueue_style('orderstorm_ecommerce_product_details_style_sheet');
	}
}

function orderstorm_ecommerce_load_widgets()
{
	if (!is_admin())
	{
		wp_enqueue_script('jquery_topzindex', plugin_dir_url(__FILE__) . 'js/jquery.topzindex.min.js', array('jquery'), '1.2', false);
		wp_enqueue_script('ostrm_categories_menu', plugin_dir_url(__FILE__) . 'js/ostrm_categories_menu.js', array('jquery'), '1.0', false);
	}
	register_widget('orderstorm_ecommerce_categories_menu');
	register_widget('orderstorm_ecommerce_shopping_cart_status');
}

function orderstorm_ecommerce_flush_rewrite_rules()
{
	global $wp_rewrite;
	
	if ($GLOBALS['osws']->need_to_flush_rules())
	{
		$wp_rewrite->flush_rules($hard = true);
	}
}

function orderstorm_ecommerce_insert_rewrite_rules($rules)
{
	return $GLOBALS['osws']->get_url_rewrite_rules() + $rules;
}

function orderstorm_ecommerce_insert_rewrite_query_vars($vars)
{
	return $GLOBALS['osws']->add_rewrite_query_vars($vars);
}

function activate_orderstorm_ecommerce_plugin()
{
	add_option('orderstorm_ecommerce_key_guid', '{9B7A2964-78CE-45DB-968E-725447AEB534}', '', 'yes');	// This is the test key
	add_option('orderstorm_ecommerce_host_name', 'kilo.orderstorm.com', '', 'yes');	
	add_option('orderstorm_ecommerce_categories_menu_cache_timestamps', array(), '', 'yes');
	
	$GLOBALS['osws'] = new OrderStormECommerceForWordPress();
	
	$product_category_page_id = $GLOBALS['osws']->get_page_id_by_slug($GLOBALS['osws']->get_product_category_page_slug());
	$product_page_id = $GLOBALS['osws']->get_page_id_by_slug($GLOBALS['osws']->get_product_page_slug());
	
	if (is_null($product_category_page_id))
	{
		$page = array
		(
			'post_type' => 'page',
			'post_name' => $GLOBALS['osws']->get_product_category_page_slug(),	// Default should be 'OrderStorm-ecommerce-category-page', when using the test key
			'post_title' => $GLOBALS['osws']->get_product_category_page_slug(),
			'post_content' => '[orderstorm_ecommerce_display_product_category_page]', 
			'post_status' => 'publish'
		);
		wp_insert_post($post = $page, $wp_error = FALSE);
	}
	
	if (is_null($product_page_id))
	{
		$page = array
		(
			'post_type' => 'page',
			'post_name' => $GLOBALS['osws']->get_product_page_slug();	// Default should be 'OrderStorm-ecommerce-product-page', when using the test key
			'post_title' => $GLOBALS['osws']->get_product_page_slug(),
			'post_content' => '[orderstorm_ecommerce_display_product_page]', 
			'post_status' => 'publish'
		);
		wp_insert_post($post = $page, $wp_error = FALSE);
	}
}

function deactivate_orderstorm_ecommerce_plugin()
{
	unregister_setting('orderstorm_ecommerce_main_settings_group', 'orderstorm_ecommerce_key_guid', 'orderstorm_ecommerce_validated_key');
	unregister_setting('orderstorm_ecommerce_advanced_settings_group', 'orderstorm_ecommerce_host_name', 'orderstorm_ecommerce_validated_host_name');
}

function create_orderstorm_ecommerce_option_menu()
{
	add_menu_page(
		__('OrderStorm e&#x2011;Commerce - Main Settings'),
		__('OrderStorm e&#x2011;Commerce'),
		'administrator',
		'orderstorm_ecommerce_settings_menu',
		'orderstorm_ecommerce_main_settings_page'
	);
	add_submenu_page(
		'orderstorm_ecommerce_settings_menu',
		__('OrderStorm e&#x2011;Commerce - Main Settings'),
		__('Main'),
		'administrator',
		'orderstorm_ecommerce_settings_menu',
		'orderstorm_ecommerce_main_settings_page'
	);
	add_submenu_page(
		'orderstorm_ecommerce_settings_menu',
		__('OrderStorm e&#x2011;Commerce - Product Category Settings'),
		__('Product Categories'),
		'administrator',
		'orderstorm_ecommerce_product_categories_menu_option',
		'orderstorm_ecommerce_product_category_settings_page'
	);
	add_submenu_page(
		'orderstorm_ecommerce_settings_menu',
		__('OrderStorm e&#x2011;Commerce - Product Settings'),
		__('Products'),
		'administrator',
		'orderstorm_ecommerce_products_menu_option',
		'orderstorm_ecommerce_product_settings_page'
	);
	add_submenu_page(
		'orderstorm_ecommerce_settings_menu',
		__('OrderStorm e&#x2011;Commerce - Shopping Cart Image URL Settings'),
		__('Cart Image URLs'),
		'administrator',
		'orderstorm_ecommerce_shopping_cart_image_URL_menu_option',
		'orderstorm_ecommerce_shopping_cart_image_URL_settings_page'
	);
	add_submenu_page(
		'orderstorm_ecommerce_settings_menu',
		__('OrderStorm e&#x2011;Commerce - Advanced Settings'),
		__('Advanced'),
		'administrator',
		'orderstorm_ecommerce_advanced_settings_menu_option',
		'orderstorm_ecommerce_advanced_settings_page'
	);
	add_action('admin_init', 'register_orderstorm_ecommerce_options');
}

function register_orderstorm_ecommerce_options()
{
	register_setting('orderstorm_ecommerce_main_settings_group', 'orderstorm_ecommerce_key_guid', 'orderstorm_ecommerce_validated_key');
	register_setting('orderstorm_ecommerce_advanced_settings_group', 'orderstorm_ecommerce_host_name', 'orderstorm_ecommerce_validated_host_name');
}

function orderstorm_ecommerce_validated_key($key_GUID)
{
	$GLOBALS['osws']->delete_categories_menu_cache();
	
	if (OrderStormECommerceForWordPress::isWellFormedGUID($key_GUID))
	{
		return $key_GUID;
	}
	else
	{
		return '';
	}
}

function orderstorm_ecommerce_validated_host_name($host_name)
{
	$host_name = trim($host_name);
	
	if (strlen($host_name) > 0)
	{
		if(substr($host_name, -1) === '/')
		{
			$host_name = substr($host_name, 0, -1);
		}
	}
	
	if (!(OrderStormECommerceForWordPress::isValidIPv4address($host_name) || OrderStormECommerceForWordPress::isValidHostName($host_name)))
	{
		$host_name = '';
	}
	
	return $host_name;
}

function orderstorm_ecommerce_main_settings_page()
{
?>
<div class="wrap">
	<h2>OrderStorm e&#x2011;Commerce - Main</h2>
	
	<form name="OrderStormECommerceMainSettings" method="post" action="options.php">
		<?php settings_fields('orderstorm_ecommerce_main_settings_group'); ?>
		<table class="form-table">
			<tr align="top">
				<th scope="row">Version:</th>
				<td>
					<input type="text" value="<?php echo($GLOBALS['osws']->get_option('plugin_version')); ?>" readonly="readonly" />
				</td>
			</tr>
			<tr align="top">
				<th scope="row">Key:</th>
				<td>
					<input type="text" name="orderstorm_ecommerce_key_guid" style="width: 44ex;" maxlength="38" value="<?php echo(get_option('orderstorm_ecommerce_key_guid')); ?>" />
				</td>
			</tr>
		</table>
		<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes'); ?>"/>
		</p>
	</form>
</div><?php
}

function orderstorm_ecommerce_product_category_settings_page()
{
?>
<div class="wrap">
	<h2>OrderStorm e&#x2011;Commerce - Product Categories</h2>
	<p>
	For implementing &quot;Product Category Pages&quot; in this site, a <b>Page</b> needs to exist, containing the following <b>Shortcode</b>: <b><code>[orderstorm_ecommerce_display_product_category_page]</code></b>.
	The corresponding <b>Page Slug</b> should be typed in the <b><i>category page slug</i></b> field in the <b>category page</b> section of your site&#39;s <b>OrderStorm.com Storefront Settings</b> page.
	You can determine or edit the corresponding <b>Page Slug</b> in the <b>Permalink</b> field when you edit the corresponding <b>Page</b>. It is the last segment of the permalink, presented between "<b>/</b>" (forward slash) characters.
	</p>
	<form name="OrderStormECommerceProductCategorySettings" method="post" action="options.php">
		<table class="form-table">
<?php
	$product_category_page_slug = $GLOBALS['osws']->get_product_category_page_slug();
?>
			<tr align="top">
				<th scope="row">Product category page slug:</th>
				<td>
					<input type="text" name="orderstorm_ecommerce_product_category_page_slug" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_product_category_page_slug()); ?>" readonly="readonly" />
				</td>
			</tr>
			<tr align="top">
				<th scope="row">Product category page ID:</th>
				<td>
<?php
	$product_category_page_id = OrderStormECommerceForWordPress::get_page_id_by_slug($product_category_page_slug);
	$product_category_page_is_published = OrderStormECommerceForWordPress::is_page_published($product_category_page_id);
?>
					<input type="text" <?php if (!$product_category_page_id) {echo('style="color: red;" ');} ?>value="<?php echo($product_category_page_id?strval($product_category_page_id):'Page does not exist!'); ?>" readonly="readonly" />
<?php
	if ($product_category_page_id)
	{
?>
					<span style="margin-left: 10px; color: <?php echo($product_category_page_is_published?'green':'red'); ?>;"><?php echo($product_category_page_is_published?'Published':'Not published'); ?></span>
<?php
	}
?>
				</td>
			</tr>
			<tr align="top">
				<th scope="row">Use SEO-friendly product category links?</th>
				<td>
					<input type="checkbox" name="orderstorm_ecommerce_use_seo_friendly_product_category_links" value="use_seo_friendly_product_category_links" <?php if ($GLOBALS['osws']->get_use_seo_friendly_product_category_links()) {echo(' checked="checked"');} ?> disabled="disabled" />
				</td>
			</tr>
		</table>
	</form>
</div><?php
}

function orderstorm_ecommerce_product_settings_page()
{
?>
<div class="wrap">
	<h2>OrderStorm e&#x2011;Commerce - Products</h2>
	<p>
	For implementing &quot;Product Pages&quot; in this site, a <b>Page</b> needs to exist, containing the following <b>Shortcode</b>: <b><code>[orderstorm_ecommerce_display_product_page]</code></b>.
	The corresponding <b>Page Slug</b> should be typed in the <b><i>product page slug</i></b> field, in the <b>product page</b> section of your site&#39;s <b>OrderStorm.com Storefront Settings</b> page.
	You can determine or edit the corresponding <b>Page Slug</b> in the <b>Permalink</b> field when you edit the corresponding <b>Page</b>. It is the last segment of the permalink, presented between "<b>/</b>" (forward slash) characters.
	</p>
	<form name="OrderStormECommerceProductSettings" method="post" action="options.php">
		<table class="form-table">
<?php
	$product_page_slug = $GLOBALS['osws']->get_product_page_slug();
?>
			<tr align="top">
				<th scope="row">Product page slug:</th>
				<td>
					<input type="text" name="orderstorm_ecommerce_product_page_slug" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_product_page_slug()); ?>" readonly="readonly" />
				</td>
			</tr>
			<tr align="top">
				<th scope="row">Product page ID:</th>
				<td>
<?php
	$product_page_id = OrderStormECommerceForWordPress::get_page_id_by_slug($product_page_slug);
	$product_page_is_published = OrderStormECommerceForWordPress::is_page_published($product_page_id);
?>
					<input type="text" <?php if (!$product_page_id) {echo ('style="color: red;"');} ?>value="<?php echo($product_page_id?strval($product_page_id):'Page does not exist!'); ?>" readonly="readonly" />
<?php
	if ($product_page_id)
	{
?>
					<span style="margin-left: 10px; color: <?php echo($product_page_is_published?'green':'red'); ?>;"><?php echo($product_page_is_published?'Published':'Not published'); ?></span>
<?php
	}
?>
				</td>
			</tr>
			<tr align="top">
				<th scope="row">Use SEO-friendly product links?</th>
				<td>
					<input type="checkbox" name="orderstorm_ecommerce_use_seo_friendly_product_links" value="use_seo_friendly_product_links" <?php if ($GLOBALS['osws']->get_use_seo_friendly_product_links()) {echo(' checked="checked"');} ?>" disabled="disabled" />
				</td>
			</tr>
		</table>
	</form>
</div><?php
}

function orderstorm_ecommerce_shopping_cart_image_URL_settings_page()
{
?>
<div class="wrap">
	<h2>OrderStorm e&#x2011;Commerce - Shopping Cart Image URL Settings</h2>
	
	<table class="form-table">
		<tr align="top">
			<th scope="row">Cart images prefix:</th>
			<td>
				<input type="text" name="orderstorm_ecommerce_shopping_cart_image_url_prefix" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_cart_images_url()); ?>" readonly="readonly" />
			</td>
		</tr>
		<tr align="top">
			<th scope="row">SMALL images prefix:</th>
			<td>
				<input type="text" name="orderstorm_ecommerce_shopping_cart_small_image_url_prefix" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_small_images_prefix()); ?>" readonly="readonly" />
			</td>
		</tr>
		<tr align="top">
			<th scope="row">Default small image:</th>
			<td>
				<input type="text" name="orderstorm_ecommerce_default_small_image" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_default_small_image()); ?>" readonly="readonly" />
			</td>
		</tr>
		<tr align="top">
			<th scope="row">MEDIUM images prefix:</th>
			<td>
				<input type="text" name="orderstorm_ecommerce_shopping_cart_medium_image_url_prefix" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_medium_images_prefix()); ?>" readonly="readonly" />
			</td>
		</tr>
		<tr align="top">
			<th scope="row">Default medium image:</th>
			<td>
				<input type="text" name="orderstorm_ecommerce_default_medium_image" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_default_medium_image()); ?>" readonly="readonly" />
			</td>
		</tr>
		<tr align="top">
			<th scope="row">LARGE images prefix:</th>
			<td>
				<input type="text" name="orderstorm_ecommerce_shopping_cart_large_image_url_prefix" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_large_images_prefix()); ?>" readonly="readonly" />
			</td>
		</tr>
		<tr align="top">
			<th scope="row">Category image prefix:</th>
			<td>
				<input type="text" name="orderstorm_ecommerce_shopping_cart_cat_image_filename_prefix" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_category_image_prefix()); ?>" readonly="readonly" />
			</td>
		</tr>
		<tr align="top">
			<th scope="row">Default category image:</th>
			<td>
				<input type="text" name="orderstorm_ecommerce_default_category_image" style="width: 67ex;" maxlength="255" value="<?php echo($GLOBALS['osws']->get_default_category_image()); ?>" readonly="readonly" />
			</td>
		</tr>
	</table>
</div><?php
}

function orderstorm_ecommerce_advanced_settings_page()
{
?>
<div class="wrap">
	<h2>OrderStorm e&#x2011;Commerce - Advanced</h2>
	
	<form name="OrderStormECommerceAdvancedSettings" method="post" action="options.php">
		<?php settings_fields('orderstorm_ecommerce_advanced_settings_group'); ?>
		<table class="form-table">
			<tr align="top">
				<th scope="row">Host name:</th>
				<td>
					<input type="text" name="orderstorm_ecommerce_host_name" style="width: 67ex;" maxlength="255" value="<?php echo(get_option('orderstorm_ecommerce_host_name')); ?>" />
				</td>
			</tr>
		</table>
		<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes'); ?>"/>
		</p>
	</form>
</div><?php
}

function orderstorm_ecommerce_display_product_category_page($attributes)
{
	extract
	(
		shortcode_atts
		(
			array
			(
				'cat_link' => Null
			),
			$attributes
		)
	);
	$GLOBALS['osws']->prepare_category_information($cat_link);
	$GLOBALS['osws']->display_product_category_page();
}

function orderstorm_ecommerce_display_product_page()
{
	$GLOBALS['osws']->display_product_page();
}

function orderstorm_ecommerce_shopping_cart_status($idSuffix)
{
	$GLOBALS['osws']->display_shopping_cart_status($idSuffix);
}
?>
